/*
 * PowerTec SCSI driver
 *
 * Copyright (C) 1997 Russell King
 */
#ifndef POWERTECSCSI_H
#define POWERTECSCSI_H

extern int powertecscsi_detect (Scsi_Host_Template *);
extern int powertecscsi_release (struct Scsi_Host *);
extern const char *powertecscsi_info (struct Scsi_Host *);
extern int powertecscsi_proc_info (char *buffer, char **start, off_t offset,
					int length, int hostno, int inout);

#ifndef NULL
#define NULL ((void *)0)
#endif

#ifndef CAN_QUEUE
/*
 * Default queue size
 */
#define CAN_QUEUE	1
#endif

#ifndef SCSI_ID
/*
 * Default SCSI host ID
 */
#define SCSI_ID		7
#endif

#include <scsi/scsicam.h>

#ifndef HOSTS_C
#include "fas216.h"
#endif

#define POWERTECSCSI {							\
	NULL,								\
	NULL,								\
	NULL,								\
	powertecscsi_proc_info,						\
	"PowerTec SCSI",						\
	powertecscsi_detect,		/* detect		*/	\
	powertecscsi_release,		/* release		*/	\
	powertecscsi_info,		/* info			*/	\
	fas216_command,			/* command		*/	\
	fas216_queue_command,		/* queuecommand		*/	\
	fas216_abort,			/* abort		*/	\
	fas216_reset,			/* reset		*/	\
	NULL,								\
	scsicam_bios_param,		/* biosparam		*/	\
	CAN_QUEUE,			/* can queue		*/	\
	SCSI_ID,			/* scsi host id		*/	\
	SG_ALL,				/* sg_tablesize		*/	\
	CAN_QUEUE,			/* cmd per lun		*/	\
	0,				/* number of boards	*/	\
	0,				/* unchecked isa dma	*/	\
	DISABLE_CLUSTERING						\
	}

#ifndef HOSTS_C

typedef struct {
    FAS216_Info info;

    /* other info... */
} PowerTecScsi_Info;

#endif /* HOSTS_C */

#endif /* POWERTECSCSI_H */
