/*
 * linux/arch/arm/lib/fp_support.c
 *
 * Copyright (C) 1995, 1996 Russell King
 */

#include <linux/sched.h>

extern void (*fp_save)(struct fp_soft_struct *);


__asm__(
	".stabs \"fp_printk\", 11, 0, 0, 0\n\t"
	".stabs \"printk\", 1, 0, 0, 0\n\t"
	".stabs \"fp_current\", 11, 0, 0, 0\n\t"
	".stabs \"current_set\", 1, 0, 0, 0\n\t"
	".stabs \"fp_send_sig\", 11, 0, 0, 0\n\t"
	".stabs \"send_sig\", 1, 0, 0, 0\n\t");


/* export weak alias, just so that these 3 have something to
be initialized with; when the fp_emulator module binds, it will
overload these entries anyway */

#if 0

#   define weak_extern_asm(symbol)      asm (".weak " __SYMBOL_PREFIX #symbol);
#   define weak_alias_asm(original, alias) \
  asm (".weak " __SYMBOL_PREFIX #alias "\n" \
       __SYMBOL_PREFIX #alias " = " __SYMBOL_PREFIX #original);

#  define weak_alias(o, a) weak_alias_asm (o, a)
#  define weak_extern(symbol) weak_extern_asm (symbol)

# define weak_alias(original, alias) strong_alias(original, alias)
# define weak_extern(symbol)    /* Do nothing; the ref will be strong.  */


weak_alias (printk, fp_printk);
weak_alias (current_set, fp_current);
weak_alias (send_sig, fp_send_sig);
#endif

#if 0
/* Define ALIAS as a weak alias for ORIGINAL.
   If weak aliases are not available, this defines a strong alias.  */
#   define weak_alias(original, alias)  \
  .weak C_SYMBOL_NAME (alias);  \
  C_SYMBOL_NAME (alias) = C_SYMBOL_NAME (original)


/* Declare SYMBOL as weak undefined symbol (resolved to 0 if not defined).  */
#   define weak_extern(symbol)  \
  .weak C_SYMBOL_NAME (symbol)


# define weak_alias(original, alias) strong_alias(original, alias)

__asm__(
	"weak_alias (printk, fp_printk)\n\t"
	"weak_alias (current_set, fp_current)\n\t"
	"weak_alias (send_sig, fp_send_sig)\n\t"
	);

#endif	

#if 0
//# define weak_alias(original, alias) strong_alias(original, alias)
	
extern int foo1(void);
int foo(void) { return 3; }
__asm__ (" .weak other_foo\n
    other_foo = foo1");
    
//weak_alias (foo, other_foo);
#endif	
	
	
#if 0
//__asm__ (" .weak fp_printk 
//    fp_printk = printk \n ");
#endif

#if 0
int fp_printk(void) __attribute__ ((weak, alias ("printk")));
void fp_current(void) __attribute__ ((weak, alias ("current_set")));
int fp_send_sig(void) __attribute__ ((weak, alias ("send_sig")));
#endif

extern int fp_printk(void);

void fp_setup(void)
{
	struct task_struct **p;

	p = task;
	do {
		if(*p)
			fp_save(&(*p)->tss.fpstate.soft);
	}
	while (++p < task + NR_TASKS);
}
